<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class Notification extends \Zeedhi\Framework\Controller\Simple {

    protected $notificationService;

    public function __construct(\Service\Notification $notificationService){
        $this->notificationService = $notificationService;
    }

    public function getNotifications(Request\Filter $request, Response $response){
        try{
            $params = $request->getFilterCriteria()->getConditions();

            $consumersArray = $params[0]['value'];

            $notificationsArray = array();

            foreach ($consumersArray as $consumer){
                $consumerNotifications = $this->notificationService->getNotificationsByConsumer($consumer['CDCLIENTE'], $consumer['CDCONSUMIDOR']);
                foreach($consumerNotifications as $notification){
                    array_push($notificationsArray, $notification);
                }
            }

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('NotificationRepository', $notificationsArray));
        } catch(\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function setAsReaded(Request\Filter $request, Response $response){
        try{
            $params = $request->getFilterCriteria()->getConditions();

            $NRNOTIFICAAPP = $params[0]['value'];

            $this->notificationService->setAsReaded($NRNOTIFICAAPP);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('NotificationRepository', array()));
        } catch(\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}