<?php

namespace Service;

class Notification {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }
    
    public function getNotificationsByConsumer($CDCLIENTE, $CDCONSUMIDOR){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_NOTIFICATIONS_BY_CONSUMER, $params);
    }

    public function setAsReaded($NRNOTIFICAAPP){
        $params = array(
            ':NRNOTIFICAAPP' => $NRNOTIFICAAPP
        );
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::SET_NOTIFICATION_AS_READED, $params);
    }

    public function getNonReadedNotificationsByConsumer($CDCLIENTE, $CDCONSUMIDOR){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_NON_READED_NOTIFICATIONS_BY_CONSUMER, $params);
    }
}