describe("MemoryStorageEngine", function() {
	var ZhLogger;
	var requestDataSourceEngine;
	var requestFactory;
	var requestEngine;
	var memoryStorageEngine;
	var values = [
		{
			nome: "ana"
		},
		{
			nome: "maria"
		},
		{
			nome: "jose"
		}
	];
	var http = function() {};
	var testStorageName = "testStorage";
	var Query;
	var zhPromise;
	var eventEngine;
	var eventAggregator;
	var templateManager;
	var restEngine;
	var dataSourceHolder;
	var zhUtil;

	beforeEach(inject(function() {
		window.templateUrls = [{ package: "default", baseUrl: "" }];
		Query = new QueryBuilder();
		zhPromise = new ZHPromise(Q);
		eventEngine = new EventEngine(
			new EventFactory(new MethodBuilder({}, {
				/*jslint evil: true */
				$eval: function(a, b) {
					a = "var args = b.args;" + a;
					return eval(a, b);
				}
			}), {}),
			new EventHandler({}, {}, console),
			{
				updateTemplate: function() {
					updateTemplate = true;
				}
			},
			{
				i18n: function(a) {
					return a;
				}
			},
			{logEvent:function() {}}
		);
		eventAggregator = new EventAggregator(eventEngine);
		templateManager = new TemplateManager(window, zhPromise);
		restEngine = {
			requestMetaData: function(){
				return new Promise(function (dataName, dataParams, callBack, baseUrl, resolve, reject){
					callBack(values);
				});
			}
		};
		dataSourceHolder = new DataSourceHolder(zhPromise, restEngine, {});
		zhUtil = new ZhUtil({}, {}, {}, dataSourceHolder);

		memoryStorageEngine = new MemoryStorageEngine(ZhLogger, requestDataSourceEngine, requestFactory, requestEngine, templateManager,
			dataSourceHolder, zhPromise, zhUtil , {});
	}));

	it("Should set dataSource and get the items correctly", function(done) {
		var _dataSource;
		memoryStorageEngine.setDataSource(testStorageName, values).then(function(){
			memoryStorageEngine.getDataSource(testStorageName).then(function(response) {
				expect(response).toEqual(values);
				var newValues = Util.clone(values);
				values.push("carlos");
				expect(response).not.toEqual(values);
				expect(response).toEqual(newValues);
				done();
			});
		});
	});
});