describe("PreferencesController", function(){
	var widget, preferencesDecorator, restEngine, $httpBackend, preferencesController;

	var zhPromise = new ZHPromise(Q);
	var query = new QueryBuilder();
	var aclEngine = new AclEngine();
	var containerMerger =  new ContainerMerger();
	var zhFeatures = new ZhFeatures();
	var zhLogger = {
		error: function(){}
	};

	var repositoryFactory = {
		factory: function(repositoryName){
			return {
				find: function(query){
					query = query.where()[0];
					if(repositories[this.name][0]){
						if((query.operator == "<>" && repositories[this.name][0][query.name] != query.value) || (query.operator == "=" && repositories[this.name][0][query.name] == query.value)){
							return zhPromise.when(repositories[this.name][0]);
						} else {
							return zhPromise.when([]);
						}
					} else {
						return zhPromise.when([]);
					}
				},
				findOne: function(query){
					query = query.where()[0];
					if(repositories[this.name][0]){
						if((query.operator == "<>" && repositories[this.name][0][query.name] != query.value) || (query.operator == "=" && repositories[this.name][0][query.name] == query.value)){
							return zhPromise.when(repositories[this.name][0]);
						} else {
							return zhPromise.when([]);
						}
					} else {
						return zhPromise.when([]);
					}
				},
				save: function(data){
					repositories[this.name].push(data);
					return zhPromise.when();
				},
				remove: function(query){
					repositories[this.name] = [];
					return zhPromise.when();
				},
				clearAll: function(){
					repositories[this.name] = [];
					return zhPromise.when();
				},
				"name": repositoryName
			};
		}
	};

	var zhUtil = {
		registerDataSource : function(){}
	};
	var currentPopup;
	var screenService = {
		hideLoader : function(){},
		showLoader : function(){},
		openPopup: function(popup){ currentPopup =  popup;},
		closePopup: function(){},
		i18n : function(text){
			return text;
		},
		updateTemplate: function(){ return zhPromise.when();},
		isPopupOpen: function(){ return false;}
	};

	var templateManager = {
		getMappedPackages: function(){
			return {
				zeedhiFramework : "../../../frontend/assets/",
				default : ["./"]
			};
		},
		getMappedServicePackages: function(){
			return {
				default : ["../backend/service/index.php"]
			};
		},
		project: {
			"zhStoragePath": "http://192.168.122.54/zhStorage/backend/service/index.php",
				"preferences": [
						{
								"value": 1,
								"dbName": "samplePreferences",
								"collectionName": "global",
								"label": "Preferências globais"
						},
						{
								"value": 2,
								"dbName": "samplePreferences",
								"collectionName": "company",
								"label": "Preferências da empresa"
						},
						{
								"value": 3,
								"dbName": "samplePreferences",
								"collectionName": "user",
								"label": "Preferências de usuário"
						}
				]
		},
		container: {
			"id": "5981681535997837841311",
			"name": "RESOURCES",
			"label": "Recursos",
			"popup": "component/popup.html",
			"template": "container/window.html",
			"footer": "component/footer.html",
			"menuTemplate": "component/menu.html",
			"widgets": [
				{
					"id": "1589480893548017881312",
					"name": "RESOURCE_LIST",
					"label": "Lista de recursos",
					"isVisible": true,
					"primaryProperty": "ID",
					"parentProperty": "PARENT",
					"expandingProperty": "NAME",
					"template": "widget/grid.html",
					"events": [],
					"actions": [],
					"fields": [
						{
							"id": "1589480892434749191313",
							"label": "Nome",
							"name": "NAME",
							"template": "field/text-edit.html",
							"isVisible": true,
							"showOnList": true,
							"descending": true,
							"sideColumn": true,
							"align": "left",
							"events": [
								{
									"name": "FieldOnClick",
									"code": "SampleController.cellClick(args)",
									"id": "15894808925626689541314"
								}
							]
						},
						{
							"id": "15894808914768177721315",
							"label": "Salário",
							"name": "SALARY",
							"showOnList": true,
							"isVisible": true,
							"align": "right",
							"reportAlign": "right",
							"isNumber": true,
							"descending": true,
							"expression": "SUM",
							"disableOrdering": false,
							"mask": {
								"type": "currency"
							},
							"inlineEditable": "number",
							"events": [
								{
									"name": "FieldInlineEdit",
									"code": "SampleController.fieldInlineEdit(args)",
									"id": "15894808930746711601316"
								}
							]
						},
						{
							"id": "15894808934775442971317",
							"label": "Tipo",
							"template": "field/text-edit.html",
							"name": "TYPE",
							"showOnList": true,
							"align": "left",
							"grouped": false,
							"descending": true
						},
						{
							"id": "15894808915629082081318",
							"label": "Data",
							"name": "DATE",
							"showOnList": true,
							"filterProperties": {
									"operator": ">"
							},
							"template": "field/calendar.html"
						}
					]
				}
			]
		}
	};

	var repositories = {
		"/samplePreferences-global":[{"preference":"Victor Barbosa","preferenceType":1,"_id":1464879127791,"toSync":true,"containerId":"5981681535997837841311","widgetId":"1589480893548017881312", "mapUserIdDefault": {"default" : false},"containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[]}]}}],
		"/samplePreferences-user": [{"_id":"57504734076800366fcfcaf9","preference":"Victor Tostes","preferenceType":3,"containerId":"5981681535997837841311","widgetId":"1589480893548017881312", "mapUserIdDefault": {"default" : false},"containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[{"id":"1589480892434749191313","name":"NAME","label":"Nome","align":"left","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808914768177721315","name":"SALARY","label":"Salário","align":"right","isVisible":false,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808934775442971317","name":"TYPE","label":"Tipo","align":"left","isVisible":false,"grouped":true,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808915629082081318","name":"DATE","label":"Data","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false}]}]},"__is_new":false,"changed":true}, {"_id":"57504734076800366fcfcaf9", "mapUserIdDefault": {"default" : false},"preference":"Victor Tostes","preferenceType":3,"containerId":"5981681535997837841311","widgetId":"1589480893548017881312","containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[{"id":"1589480892434749191313","name":"NAME","label":"Nome","align":"left","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808914768177721315","name":"SALARY","label":"Salário","align":"right","isVisible":false,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808934775442971317","name":"TYPE","label":"Tipo","align":"left","isVisible":false,"grouped":true,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808915629082081318","name":"DATE","label":"Data","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false}]}]},"__is_new":false,"changed":true}],
		"/samplePreferences-company": [{"_id":"57505e80076800b06ecfcaf9","preference":"Wagão","preferenceType":2,"containerId":"5981681535997837841311","widgetId":"1589480893548017881312", "mapUserIdDefault": {"default" : false},"containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[]}]},"__is_new":false,"__deleted":true}]
	};

	var containerDiff = {
		"id": "5981681535997837841311",
		"widgets": [{
			"id": "1589480893548017881312",
			"fields": [{
				"id": "1589480892434749191313",
				"name": "NAME",
				"label": "Nome",
				"align": "left",
				"isVisible": true,
				"grouped": false,
				"fixed": false,
				"__isSelected": false,
				"__notSelectable": false
			}, {
				"id": "15894808914768177721315",
				"name": "SALARY",
				"label": "Salário",
				"align": "right",
				"isVisible": false,
				"grouped": false,
				"fixed": false,
				"__isSelected": false,
				"__notSelectable": false
			}, {
				"id": "15894808934775442971317",
				"name": "TYPE",
				"label": "Tipo",
				"align": "left",
				"isVisible": false,
				"grouped": true,
				"fixed": false,
				"__isSelected": false,
				"__notSelectable": false
			}, {
				"id": "15894808915629082081318",
				"name": "DATE",
				"label": "Data",
				"isVisible": true,
				"grouped": false,
				"fixed": false,
				"__isSelected": false,
				"__notSelectable": false
			}]
		}]
	};

	var defaultContainer = {
			"id": "5981681535997837841311",
			"name": "RESOURCES",
			"label": "Recursos",
			"showFooter": true,
			"showHeader": true,
			"showMenu": true,
			"showBack": true,
			"showForm": true,
			"popup": "component/popup.html",
			"template": "container/window.html",
			"footer": "component/footer.html",
			"menuTemplate": "component/menu.html",
			"widgets": [
					{
							"id": "1589480893548017881312",
							"name": "RESOURCE_LIST",
							"label": "Lista de recursos",
							"isVisible": true,
							"primaryProperty": "ID",
							"parentProperty": "PARENT",
							"expandingProperty": "NAME",
							"template": "widget/grid.html",
							"itemsPerPage": 10,
							"floatingControl": {
									"position": "bottom right",
									"draggable": true,
									"searchAction": true,
									"refreshAction": true,
									"configAction": true,
									"actions": [{
											"label": "pizza",
											"icon": "pizza",
											"events": [{
													"name": "ActionEvent",
													"code": "ScreenService.successNotification('pizza!');"
											}]
									}]
							},
							"events": [
									{
											"name": "WidgetAfterMoveRow",
											"code": "ScreenService.alertNotification(args.row.SALARY)",
											"id": "15894808936246998191327"
									},
									{
											"name": "WidgetOnSaveInlineEdit",
											"code": "SampleController.saveResources(args)",
											"id": "1589480895496266001328"
									},
									{
											"name": "WidgetOnCancelInlineEdit",
											"code": "SampleController.cancelResources(args)",

											"id": "158948089324610621329"

									}, {
											"name": "WidgetOnEnter",
											"code": "SampleController.victorTeste(args.owner)",
											"id": 4
									}
							],
							"showCheckbox": true,
							"styles": [
									{
											"condition": "row.ID % 2 === 0",
											"cssClass": "zh-inactive"
									}
							],
							"actions": [
									{
											"name": "NEW",
											"isVisible": true,
											"icon": "plus no-border",
											"label": "New ",
											"showAsAction": "grid-right",
											"tooltip": "inserir novo item",
											"events": [
													{
															"name": "ActionEvent",
															"code": "ScreenService.showMessage('It works!')",
															"id": "1589480891951848201320"
													}
											],
											"id": "15894808917501489921319"
									},
									{
											"name": "NEW",
											"isVisible": true,
											"icon": "search",
											"showAsAction": "grid-left",
											"condition": "row.SALARY >= 2000",
											"tooltip": "Pesquisar",
											"events": [
													{
															"name": "ActionEvent",
															"code": "ScreenService.showMessage('It works!')",
															"id": "1589480897549745361322"
													}
											],
											"id": "15894808938399581081321"
									},
									{
											"name": "CUSTOM_PDF_REPORT",
											"isVisible": true,
											"icon": "printer",
											"label": "Custom PDF report",
											"showAsAction": "always",
											"tooltip": "Custom PDF report",
											"events": [
													{
															"name": "ActionEvent",
															"code": "SampleController.openCustomPDFReport(args.owner.widget)",
															"id": "15894808924902741661324"
													}
											],
											"id": "15894808917477704141323"
									},
									{
											"name": "CUSTOM_XLS_REPORT",
											"isVisible": true,
											"icon": "printer",
											"label": "Custom XLS report",
											"showAsAction": "always",
											"tooltip": "Custom XLS report",
											"events": [
													{
															"name": "ActionEvent",
															"code": "SampleController.openCustomXLSReport(args.owner.widget)",
															"id": "158948089754443231326"
													}
											],
											"id": "15894808914825457461325"
									},
									{
											"name": "FILTER",
											"isVisible": true,
											"icon": "filter",
											"label": "Filter",
											"showAsAction": "always",
											"tooltip": "Filter",
											"events": [
													{
															"name": "ActionEvent",
															"code": "SampleController.openFilter(args.owner.widget)",
															"id": "13894808924902741661324"
													}
											],
											"id": "15894808917477704141323"
									}
							],
							"dataSource": {
									"name": "/resourses",
									"rest": false,
									"localStorage": true
							},
							"dataSourceFilter": [
									{
											"name": "SALARY",
											"value": "500",
											"operator": ">"
									}
							],
							"fields": [
									{
											"id": "1589480892434749191313",
											"label": "Nome",
											"name": "NAME",
											"template": "field/text-edit.html",
											"isVisible": true,
											"showOnList": true,
											"descending": true,
											"sideColumn": true,
											"align": "left",
											"events": [
													{
															"name": "FieldOnClick",
															"code": "SampleController.cellClick(args)",
															"id": "15894808925626689541314"
													}
											]
									},
									{
											"id": "15894808914768177721315",
											"label": "Salário",
											"name": "SALARY",
											"showOnList": true,
											"isVisible": true,
											"align": "right",
											"reportAlign": "right",
											"isNumber": true,
											"descending": true,
											"expression": "SUM",
											"disableOrdering": false,
											"mask": {
													"type": "currency"
											},
											"inlineEditable": "number",
											"events": [
													{
															"name": "FieldInlineEdit",
															"code": "SampleController.fieldInlineEdit(args)",
															"id": "15894808930746711601316"
													}
											]
									},
									{
											"id": "15894808934775442971317",
											"label": "Tipo",
											"template": "field/text-edit.html",
											"isVisible": true,
											"name": "TYPE",
											"showOnList": true,
											"align": "left",
											"grouped": false,
											"descending": true
									},
									{
											"id": "15894808915629082081318",
											"label": "Data",
											"name": "DATE",
											"showOnList": true,
											"filterProperties": {
													"operator": ">"
											},
											"template": "field/calendar.html"
									}
							],
							"widgets": []
					}
			]
	};

	var EventAggregator = {
		onRequestStart : function() {},
		onRequestSuccess : function() {},
		onRequestRetry : function() {},
		onRequestError: function() {},
		subscribe: function() {}
	};

	var localStorageEngine, requestDataSourceEngine, SQLStorageStrategy = {
		requestMetaData: function () {
			return Q.when({});
		}
	};

	var eventEngine = new EventEngine(new EventFactory(new MethodBuilder({}, {
		/*jslint evil: true */
		$eval: function (a, b) {
			return eval(a, b);
		}
	}), {}), new EventHandler({}, {}, console), {
		updateTemplate: function () {}
	}, {
		i18n: function (text) {
			return text;
		}
	});

	var metaDataFactory = new MetaDataFactory(localStorageEngine, requestDataSourceEngine,
	SQLStorageStrategy, restEngine, eventEngine, screenService, aclEngine, {
		project: {}
	}, new ZhUtil({}), Q, {
		getDataSourceLazy: function () {}
	});

	var containerFactored = metaDataFactory.containerFactory(defaultContainer);
	widget = containerFactored.widgets[0];

	var carouselWidgetCreator = new CarouselWidgetCreator(metaDataFactory, screenService);

	var preferencesPermissionsHandler = new PreferencesPermissionsHandler(preferencesDecorator, templateManager);

	preferencesPermissionsHandler.preferencesUser.registerPreferenceUser("1212312", {
		"edit": {
			"1" : true,
			"2": false,
			"3": true
		},
		"view": {
			"1" : true,
			"2": true,
			"3": true
		},
		"default": {
			"1" : true,
			"2": true,
			"3": true
		}
	});

	beforeEach(inject(function(_$http_, _$httpBackend_, _$rootScope_) {
		$httpBackend = _$httpBackend_;
		$http = _$http_;
		scope = _$rootScope_;
		scope.nextWidget = function(){};
		scope.previousWidget = function(){};
		$httpBackend.when('DELETE', 'http://192.168.122.54/zhStorage/backend/service/index.php/remove/samplePreferences/user').respond({"dataset":{"response":{"ns":"samplePreferences.user","nIndexesWas":1,"ok":1}}}, {});
		$httpBackend.when('GET', 'http://192.168.122.54/zhStorage/backend/service/index.php/findAll/samplePreferences/user').respond({"dataset":{"foundData":[{"_id":"57504734076800366fcfcaf9","preference":"Victor Tostes", "mapUserIdDefault": {"default" : false},"preferenceType":3,"containerId":"5981681535997837841311","widgetId":"1589480893548017881312","containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[{"id":"1589480892434749191313","name":"NAME","label":"Nome","align":"left","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808914768177721315","name":"SALARY","label":"Salário","align":"right","isVisible":false,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808934775442971317","name":"TYPE","label":"Tipo","align":"left","isVisible":false,"grouped":true,"fixed":false,"__isSelected":false,"__notSelectable":false},{"id":"15894808915629082081318","name":"DATE","label":"Data","isVisible":true,"grouped":false,"fixed":false,"__isSelected":false,"__notSelectable":false}]}]},"__is_new":false,"changed":true}]}}, {});
		$httpBackend.when('POST', 'http://192.168.122.54/zhStorage/backend/service/index.php/save/samplePreferences/user').respond({}, {});
		$httpBackend.when('DELETE', 'http://192.168.122.54/zhStorage/backend/service/index.php/remove/samplePreferences/global').respond({"dataset":{"response":{"ns":"samplePreferences.global","nIndexesWas":1,"ok":1}}}, {});
		$httpBackend.when('GET', 'http://192.168.122.54/zhStorage/backend/service/index.php/findAll/samplePreferences/global').respond({"dataset": {"foundData": [{"_id": "57504911076800a26ecfcaf9","preference": "Victor Barbosa", "mapUserIdDefault": {"default" : false},"preferenceType": 1,"containerId": "5981681535997837841311","widgetId": "1589480893548017881312","containerDiff": {"id": "5981681535997837841311","widgets": [{"id": "1589480893548017881312","fields": []}]}}]}}, {});
		$httpBackend.when('POST', 'http://192.168.122.54/zhStorage/backend/service/index.php/save/samplePreferences/global').respond({"_id":"574db2f40768002835cfcaf9","preference":"Victor Tostes","preferenceType":3, "mapUserIdDefault": {"default" : false},"containerId":"5981681535997837841311","widgetId":"1589480893548017881312","containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[{"id":"1589480892434749191313","name":"NAME","label":"Nome","align":"left","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":1,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808914768177721315","name":"SALARY","label":"Salário","align":"right","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":2,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808934775442971317","name":"TYPE","label":"Tipo","align":"left","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":3,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808915629082081318","name":"DATE","label":"Data","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":4,"qtdRows":4,"__isSelected":false,"__notSelectable":false}]}]},"__is_new":false,"changed":true}, {});
		$httpBackend.when('DELETE', 'http://192.168.122.54/zhStorage/backend/service/index.php/remove/samplePreferences/company').respond({"dataset":{"response":{"ns":"samplePreferences.company","nIndexesWas":1,"ok":1}}}, {});
		$httpBackend.when('GET', 'http://192.168.122.54/zhStorage/backend/service/index.php/findAll/samplePreferences/company').respond({"dataset":{"foundData":[]}}, {});
		$httpBackend.when('POST', 'http://192.168.122.54/zhStorage/backend/service/index.php/save/samplePreferences/company').respond({"_id":"574db2f40768002835cfcaf9","preference":"Victor Tostes","preferenceType":3, "mapUserIdDefault": {"default" : false},"containerId":"5981681535997837841311","widgetId":"1589480893548017881312","containerDiff":{"id":"5981681535997837841311","widgets":[{"id":"1589480893548017881312","fields":[{"id":"1589480892434749191313","name":"NAME","label":"Nome","align":"left","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":1,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808914768177721315","name":"SALARY","label":"Salário","align":"right","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":2,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808934775442971317","name":"TYPE","label":"Tipo","align":"left","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":3,"qtdRows":4,"__isSelected":false,"__notSelectable":false},{"id":"15894808915629082081318","name":"DATE","label":"Data","isVisible":true,"grouped":false,"fixed":false,"sequenceInList":4,"qtdRows":4,"__isSelected":false,"__notSelectable":false}]}]},"__is_new":false,"changed":true}, {});
		restEngine = new RestEngine(zhLogger, $http, templateManager, screenService, zhFeatures, zhPromise, EventAggregator);
		preferencesDecorator = new PreferencesDecorator(zhPromise, repositoryFactory, restEngine, screenService, templateManager, containerMerger, zhUtil, query);
		preferencesDecorator.syncRepositoryData();
		var restEngineRequest = restEngine.request.bind(RestEngine);
		restEngine.request = function () {
			var result = restEngineRequest.apply(restEngine, arguments);
			$httpBackend.flush();
			return result;
		};
		preferencesController = new PreferencesController(templateManager, screenService, query, zhPromise, preferencesDecorator, metaDataFactory, carouselWidgetCreator, EventAggregator, preferencesPermissionsHandler);
	}));

	it("Factory carousel widget", function(){
		preferencesController.startConfig(widget);
		expect(currentPopup.template).toEqual("widget/carousel.html");
		expect(currentPopup.widgets.length).toEqual(5);
	});

	it("Build dataSource of preferences list widget", function(done){
		preferencesController.startConfig(widget);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			expect(currentPopup.widgets[0].dataSource.data.length).toEqual(2);
			done();
		});
	});

	it("Open popup new preference test", function(){
		preferencesController.startConfig(widget);
		currentPopup.widgets[0].openNewPreferenceWidget(currentPopup.widgets[0]);
		expect(currentPopup.name).toEqual("newPreferenceWidget");
		expect(currentPopup.fields[1].dataSource.data.length).toEqual(2);
	});

	it("Apply preference on container test", function(done){
		preferencesController.startConfig(widget);
		currentPopup.widgets[0].applyPreference({"_id": "57504734076800366fcfcaf9", "preferenceType": 3 });
		zhPromise.when().then(function(){
			expect(templateManager.container.widgets[0].fields[1].isVisible).toEqual(false);
			expect(templateManager.container.widgets[0].fields[1].isVisible_original).toEqual(true);
			done();
		});
	});

	it("Restore dafult container test", function(){
		preferencesController.startConfig(widget);
		currentPopup.widgets[0].restoreDefaultContainer();
		expect(templateManager.container.widgets[0].fields[1].isVisible).toEqual(true);
		expect(templateManager.container.widgets[0].fields[1].isVisible_original).toEqual(undefined);
	});

	it("Close popup and run digest", function(){
		preferencesController.startConfig(widget);
		currentPopup.widgets[0].closePopupAndRunDigest();
		expect(scope._currentPopup).toEqual(undefined);
	});

	it("Save a new preference test", function(done) {
		preferencesController.startConfig(widget);
		scope.widget = currentPopup;
		CarouselController(scope, scope);
		currentPopup.widgets[0].openNewPreferenceWidget(currentPopup.widgets[0]);
		currentPopup.currentRow.name = "Victor Barbosa";
		currentPopup.currentRow.type = 1;
		currentPopup.createNewPreference(currentPopup).then(function(){
			expect(scope._currentPopup.name).toEqual("PreferenceDetailsWidget");
			done();
		});
	});

	it("Change field order up test", function(){
		preferencesController.startConfig(widget);
		currentPopup.widgets[1].dataSource.data[0].sequenceInList = 1;
		currentPopup.widgets[1].dataSource.data[1].sequenceInList = 2;
		currentPopup.widgets[1].dataSource.data[2].sequenceInList = 3;
		currentPopup.widgets[1].dataSource.data[3].sequenceInList = 4;
		currentPopup.widgets[1].changeOrder(1, 1, currentPopup.widgets[1]);
		currentPopup.widgets[1].changeOrder(4, -1, currentPopup.widgets[1]);
		expect(currentPopup.widgets[1].dataSource.data[0].name).toEqual("SALARY");
		expect(currentPopup.widgets[1].dataSource.data[1].name).toEqual("NAME");
		expect(currentPopup.widgets[1].dataSource.data[2].name).toEqual("DATE");
		expect(currentPopup.widgets[1].dataSource.data[3].name).toEqual("TYPE");
	});

	it("Method saveFieldsettings should save field changes", function(done){
		preferencesController.startConfig(widget);
		scope.widget = currentPopup;
		CarouselController(scope, scope);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].openEditPreference(currentPopup.widgets[0], currentPopup.widgets[0].dataSource.data[1]);
			currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[1].isVisible = false;
			currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[2].grouped = true;
			currentPopup.widgets[1].saveFieldSettings(currentPopup.widgets[1]).then(function(){
				expect(currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[1].isVisible).toEqual(false);
				expect(currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[2].grouped).toEqual(true);
				done();
			});
		});
	});

	it("Method saveFieldsettings should save field changes and apply preference", function(done){
		preferencesController.startConfig(widget);
		scope.widget = currentPopup;
		CarouselController(scope, scope);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].openEditPreference(currentPopup.widgets[0], currentPopup.widgets[0].dataSource.data[1]);
			currentPopup.widgets[1].dataSource.data[1].isVisible = true;
			currentPopup.widgets[1].dataSource.data[1].grouped = false;
			currentPopup.widgets[1].saveAndApplyPreference(currentPopup.widgets[1]).then(function(){
				expect(currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[1].isVisible).toEqual(true);
				expect(currentPopup.widgets[0].dataSource.data[1].containerDiff.widgets[0].fields[1].grouped).toEqual(false);
				done();
			});
		});
	});

	it("Method openPopupPreferencesProperty should open field properties form", function(done){
		preferencesController.startConfig(widget);
		scope.widget = currentPopup;
		CarouselController(scope, scope);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].openEditPreference(currentPopup.widgets[0], currentPopup.widgets[0].dataSource.data[1]);
			currentPopup.widgets[1].openPopupPreferencesProperty(currentPopup.widgets[1], currentPopup.widgets[1].dataSource.data[0]);
			expect(scope._currentPopup.name).toEqual("properties_widget");
			done();
		});
	});

	it("Method saveFieldChanges should update the preference's fiels properties", function(done){
		preferencesController.startConfig(widget);
		scope.widget = currentPopup;
		CarouselController(scope, scope);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].openEditPreference(currentPopup.widgets[0], currentPopup.widgets[0].dataSource.data[1]);
			currentPopup.widgets[1].dataSource.data[0].label = "NewNameToTest";
			currentPopup.widgets[2].saveFieldChanges(currentPopup.widgets[2], currentPopup.widgets[1].dataSource.data[0]);
			currentPopup.widgets[2].backToPreviousWidget(currentPopup.widgets[2]);
			expect(currentPopup.widgets[1].dataSource.data[0].label).toEqual("NewNameToTest");
			done();
		});
	});

	it("Method setAsDefaultPreference should set the preference as default", function(done){
		preferencesController.startConfig(widget);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].setAsDefaultPreference(currentPopup.widgets[0].dataSource.data[1], currentPopup.widgets[0]).then(function(){
				expect(currentPopup.widgets[0].dataSource.data[1].defaultPreference).toEqual(false);
				done();
			});
		});
	});

	it("Method deletePreference should delete the preference", function(done){
		preferencesController.startConfig(widget);
		preferencesController.preferencesListOnEnter(currentPopup.widgets[0]).then(function(){
			currentPopup.widgets[0].dataSource.addCheckedRows(currentPopup.widgets[0].dataSource.data[0]);
			currentPopup.widgets[0].updateCheckedRows();
			currentPopup.widgets[0].deletePreferenceClick(currentPopup.widgets[0]).then(function(){
				expect(currentPopup.widgets[0].dataSource.data.length).toEqual(1);
				done();
			});
		});
	});

});