function LoginController(ScreenService, templateManager, LoginService, FilialRepository, Utilities, ProfileService, restEngine, eventAggregator, CardapioService, RechargeService, SessionIdRepo, LayoutRepo){

    var language;

    this.prepareSystem = function(clientsField, loginWidget){
        Utilities.setIps(clientsField, function(clientsField){
            SessionIdRepo.clearAll()
            .then(LayoutRepo.clearAll);
            this.getClients(clientsField, loginWidget);
            loginWidget.newRow();
            loginWidget.moveToFirst();
            loginWidget.getField('password').value('');
            this.handleChangePassword();
            ProfileService.setOpenEdit(false);

            var username = getLocalVar('username') || null;
            var institution = getLocalVar('institution') || {'CDCLIENTE': null, 'CDFILIAL': null, 'NMFANTCLIE': null};
            var storeCheck = getLocalVar('storeCheck') || "N";

            loginWidget.setCurrentRow(Object.assign(institution, {
                "username": username,
                "storeCheck": storeCheck
            }));
            if(!institution.CDFILIAL){
                clientsField.setValue('Selecione a instituição');
            }

            // DYNAMIC LOGO SYSTEM
            const clientApp = Utilities.getClientApp();
            var logoField = loginWidget.getField('logo');
            if(clientApp === 'default'){
                logoField.source = "./images/logo_empresa.png";
            } else{
                logoField.source = "./images/" + clientApp + "/logo_empresa.png";
            }   

            /*restEngine.requestMetaData('./config.json').then(
                function (response){
                    if (response.data.logoEmpresa && response.data.logoEmpresa.length > 0){
                        var img = new Image();
                        img.onload = function(){ 
                            loginWidget.getField('logo').source = '../mobile/images/' + response.data.logoEmpresa;
                            templateManager.updateTemplate();
                        };
                        img.onerror = function(){
                            loginWidget.getField('logo').source = '../mobile/images/logo_nocash_vertical.png';
                            templateManager.updateTemplate();
                        };
                        img.onerror = function(){ loginWidget.getField('logo').source = '../mobile/images/logo_nocash_vertical.png'; };
                        img.src = '../mobile/images/' + response.data.logoEmpresa;
                    }
                    else {
                        loginWidget.getField('logo').source = '../mobile/images/logo_nocash_vertical.png';
                    }
                },
                function (){
                    ScreenService.showMessage('Erro no config.json.');
                }
            );*/
            
            if(clientApp === 'cucinare' || clientApp === 'nutrisaude'){
                loginWidget.getField('register').isVisible = true;
            }
        }.bind(this));
    };

    /* Gets the clients to be loaded into the clients drop-down. */
    this.getClients = function(clientsField, loginWidget){
        var version = Utilities.getFrontVersion();
        return LoginService.testConnection(version).then(
            function (){
                LoginService.getClients().then(function (clientData){
                    if (clientData.length == 0){
                        clientsField.dataSource.data = [];
                        ScreenService.showMessage('Não foi encontrada nenhuma instituição.');
                    }
                    else {
                        clientsField.dataSource.data = clientData;
                        if (clientData.length > 1){
                            clientsField.isVisible = true;
                        }
                        else {
                            loginWidget.currentRow.CDFILIAL = clientsField.dataSource.data[0].CDFILIAL;
                            loginWidget.currentRow.CDCLIENTE = clientsField.dataSource.data[0].CDCLIENTE;
                            clientsField.setValue(clientsField.dataSource.data[0].NMFANTCLIE);
                            clientsField.isVisible = false;
                        }
                        templateManager.updateTemplate();
                    }
                });
            },
            function (){
                clientsField.dataSource.data = [];
                clientsField.setValue('Selecione a instituição');
                ScreenService.showMessage('Não foi possível carregar a lista de instituições. Verifique sua conexão e tente novamente');
            }
        );
    };

    /* Validates the login details. */
    this.checkLoginForm = function(client, username, password) {
        //if (client == null) ScreenService.showMessage("Selecione a instituição.");
        //else if (username == null || username == "") ScreenService.showMessage("Informe o login.");
        if (username == null || username == "") ScreenService.showMessage("Informe o login.");
        else if (password == null || password == "") ScreenService.showMessage("Informe a senha.");
        else return true;
        return false;
    };

    /* Logs the user in. */
    this.login = function(client, username, password, CDFILIAL, checkbox, passwordPopup, NMFANTCLIE) {
        if (this.checkLoginForm(client, username, password)) {
            LoginService.login(client, username, password, CDFILIAL).then(
                function (loginData){
                    // Saves username and password.
                    if (checkbox == 'Y'){
                        setLocalVar('username', username);
                        setLocalVar('institution',{'CDCLIENTE': client,
                                                    'CDFILIAL': CDFILIAL,
                                                    'NMFANTCLIE': NMFANTCLIE});
                        setLocalVar('storeCheck', "Y");
                    }
                    else {
                        setLocalVar('username', null);
                        setLocalVar('institution',{'CDCLIENTE': null,
                                                    'CDFILIAL': null,
                                                    'NMFANTCLIE': null});
                        setLocalVar('storeCheck', "N");
                    }

                    if (loginData[0]){
                        if (loginData[0]['nothing']){
                            // Set a new password.
                            var data = {
                                CDCLIENTE : client,
                                NMLOGINCONS : username,
                                CDFILIAL : CDFILIAL
                            };
                            passwordPopup.setCurrentRow(data);
                            ScreenService.openPopup(passwordPopup);
                        }
                    }
                    else {
                        // Normal login.
                        //var eventToken = eventAggregator.subscribe('EventOnRequestIdle', this.idleTimeOut); // SESSION TIMEOUT EVENT.
                        //setLocalVar('eventToken', eventToken);
                        this.changeUserMenu(loginData['LoginRepository']);
                        FilialRepository.save({
                            "CDFILIAL": CDFILIAL
                        }).then(function(filial){
                            LoginService.loadBandeirasEsiTef(filial[0].CDFILIAL).then(function (dado){
                                this.configureMenu(loginData['LoginRepository']);
                                //Sanutrin login
                                //ScreenService.openSwipe(templateManager.container.getWidget('infoPopup'));
                                //Normal login
                                ScreenService.openWindow('parentDashboard');
                                $('.zh-user-photo').hide();
                            }.bind(this)).then(function(){
                                this.getPlaces(loginData['LoginRepository']['CDCLIENTE']);
                            }.bind(this));
                        }.bind(this));
                    }
                }.bind(this),
                function (){
                    ScreenService.showMessage('Erro na conexão ao servidor. Verifique as configurações de IP.');
                }
            );
        }
    };
    
    this.swipeLogin = function(){
        ScreenService.closeSwipe();
        ScreenService.openWindow('parentDashboard');
        $('.zh-user-photo').hide();
    };

    this.getPlaces = function(CDCLIENTE) {
		return CardapioService.getPlaces(CDCLIENTE);
	};

    this.acceptContract = function(row, passwordPopup, contract, clientSelectPopup){
        if (row.CDCLIENTE == null){
            row.CDCLIENTE = clientSelectPopup.currentRow.CDCLIENTE;
            row.CDFILIAL = clientSelectPopup.currentRow.CDFILIAL;
        }
        this.login(row.CDCLIENTE, row.username, row.password, row.CDFILIAL, row.storeCheck, passwordPopup, contract, true, clientSelectPopup);
    };

    this.configureMenu = function(loginData){
        var menuGroups = templateManager.project.groupMenu;
        ProfileService.enableOffOptions(loginData.CDFILIAL, loginData.CDTIPOCONS).then(function (accessParams){
            var menuGroups = templateManager.project.groupMenu;
            if (accessParams.DSACESSOSITE === "N"){
                menuGroups[2].menus[0].isVisible = false;
                menuGroups[2].menus[1].isVisible = false;
            }
            else {
                menuGroups[2].menus[0].isVisible = true;
                menuGroups[2].menus[1].isVisible = true;
            }
            /*if (Util.isDesktop()){
                menuGroups[1].menus[3].isVisible = false;
                menuGroups[1].menus[4].isVisible = true;
            }
            else {
                menuGroups[1].menus[3].isVisible = true;
                menuGroups[1].menus[4].isVisible = false;
            }*/
            templateManager.updateTemplate();
        }.bind(this));
    };

    this.setNewPassword = function (row) {
        if ((row.CDSENHACONSMD5 == null) || (row.CDSENHACONSMD5 == '')){
            ScreenService.showMessage('Informe a senha.');
        }
        else if ((row.CDSENHACONSMD52 == null) || (row.CDSENHACONSMD52 == '')){
            ScreenService.showMessage('Confirme a senha.');
        }
        else if (row.CDSENHACONSMD5 != row.CDSENHACONSMD52){
            ScreenService.showMessage('As senhas estão diferentes.');
        }
        else {
            LoginService.setPassword(row.CDCLIENTE, row.NMLOGINCONS, row.CDSENHACONSMD5, row.CDFILIAL).then(function (loginData){
                ScreenService.closePopup();
                var eventToken = eventAggregator.subscribe('EventOnRequestIdle', this.idleTimeOut); // SESSION TIMEOUT EVENT.
                setLocalVar('eventToken', eventToken);
                this.changeUserMenu(loginData['LoginRepository']);
                FilialRepository.save({
                    "CDFILIAL": row.CDFILIAL
                }).then(function(){
                    this.configureMenu(loginData['LoginRepository']);
                    ScreenService.openWindow('parentDashboard');
                }.bind(this));
            }.bind(this));
        }
    };

    this.changeUserMenu = function (loginData) {
        this.setConsumerMenu(loginData.NMRESPCONS, loginData.NMFANTCLIE);
    };

    this.setConsumerMenu = function (consumerName, attr1, attr2) {
        const clientApp = Utilities.getClientApp();
        attr1 = (attr1 != null) ? attr1 : "";
        attr2 = (attr2 != null) ? attr2 : "";
        if(clientApp === 'default'){
            ScreenService.buildUserData(consumerName, [attr1,attr2], null, "./images/user.jpg");
        } else{
            ScreenService.buildUserData(consumerName, [attr1,attr2], null, "./images/" + clientApp + "/user.jpg");
        }            
    };

    this.handleChangePassword = function () {
        var hash = window.location.search;

        if (hash) {
            setLocalVar('currentHash', hash.substr(1));
            openWindow('forgotMyPassword');
        } else {
            setLocalVar('currentHash', null);
        }
    };

    /* Forgot Password routine. */
    this.forgotPassword = function(loginData) {
        /* We need the user's client in order to know which user we're dealing with. */
        if (loginData.CDCLIENTE == null){
            ScreenService.showMessage("Selecione a instituição.");
        }
        /* Validation. */
        else if (loginData.NMLOGINCONS == null || loginData.NMLOGINCONS == ""){
            ScreenService.showMessage("Informe o login.");
        }
        else {
            LoginService.forgotPassword(loginData.CDCLIENTE, loginData.NMLOGINCONS, Utilities.appUrl, Utilities.logoEmail).then(function(){
                ScreenService.successNotification('E-mail enviado com sucesso!');
                ScreenService.closePopup();
            });
        }
    };

    /* Checks if an e-mail is valid. */
    this.isValidEmail = function(email) {
        if (email == null || email == "") {
            ScreenService.showMessage("Informe seu email.");
            return false;
        }
        else {
            /* This regular expression was said to not work in some very specific cases, but it appears to be safe for use in our case. */
            var match = email.match(/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
            return match != null;
        }
    };

    this.openIpConfigPopup = function(popup){
        ScreenService.openPopup(popup);
    };

    this.openForgotPassword = function(popup){
        popup.currentRow.CDCLIENTE = null;
        popup.currentRow.NMLOGINCONS = null;
        popup.currentRow.NMFANTCLIE = null;
        popup.currentRow.CDFILIAL = null;
        ScreenService.openPopup(popup);
    };

    this.openFAQ = function(popup){
        ScreenService.openSwipe(popup);
    };

    this.openTheWindow = function(){
        window.open('redefinir_navegador.pdf');
    };

    this.setClientsLabel = function(clientsField){
        clientsField.setValue('Selecione a instituição');
    };

    this.logoff = function(){
        LoginService.logoff().then(function (){
            ScreenService.openWindow('login');
        });
    };

    this.idleTimeOut = function(){
        LoginService.logoff().then(function (){
            eventAggregator.unSubscribe('EventOnRequestIdle', getLocalVar('eventToken'));
            ScreenService.showMessage('Sua sessão expirou e você foi redirecionado à página principal. Favor realizar o login novamente.');
            ScreenService.openWindow('login');
        });
    };

    this.loadSystemLanguage = function() {
		// Had to do this because on event 'WidgetOnEnter' the screen wasn't fully loaded
		setTimeout(_handleFlagsStyle, 2000);

		language = localStorage.getItem('lang');

		if (!language){
			language = 'pt_br';
		}
	};

    this.changeLanguage = function(selectedLanguage) {
		$('.language-flag').find('img').removeClass('selected-flag');

		language = selectedLanguage;
		_handleFlagsStyle();
	}

	var _handleFlagsStyle = function() {
		var brazilFlag = $('.brasil').find('img');
		var usaFlag = $('.usa').find('img');
		var spainFlag = $('.spain').find('img');

		brazilFlag.css('opacity','0.5');
		usaFlag.css('opacity','0.5');
		spainFlag.css('opacity','0.5');

		switch (language) {
			case 'pt_br':
				brazilFlag.toggleClass('selected-flag');
				brazilFlag.css('opacity','1');
				break;
			case 'en_us':
				usaFlag.toggleClass('selected-flag');
				usaFlag.css('opacity','1');
				break;
			case 'es':
				spainFlag.toggleClass('selected-flag');
				spainFlag.css('opacity','1');
				break;
		}

		localStorage.setItem('lang', language);
		window.lang = language;
        ScreenService.setLanguage(language);
	};

    this.forgetLogin = function(){
        setLocalVar('username', null);
        setLocalVar('institution', null);
        setLocalVar('storeCheck', "N");
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginController', LoginController);
});