function CreditCardService(requestEngine, RestEngine, requestFactory, RegisterCardRepository, Query) {

    var creditCardInformation = '';

    this.setCreditCardInformation = function(creditCard) {
        creditCardInformation = creditCard;
    };

    this.getCreditCardInformation = function() {
        return creditCardInformation;
    };
    
    var useCvv = false;
    
    this.setUseCvv = function(flagUseCvv) {
        useCvv = flagUseCvv;
    };

    this.getUseCvv = function() {
        return useCvv;
    };

    this.registerCreditCard = function(row){
        var query = Query.build()
                        .where('CD_CLIENTE').equals(row.CD_CLIENTE)
                        .where('CD_CONSUMIDOR').equals(row.CD_CONSUMIDOR)
                        .where('CD_FILIAL').equals(row.CD_FILIAL)
                        .where('NAME').equals(row.NAME)
                        .where('cardNumber').equals(row.cardNumber)
                        .where('EXP_MONTH').equals(row.EXP_MONTH)
                        .where('EXP_YEAR').equals(row.EXP_YEAR)
                        .where('CVV').equals(row.CVV)
                        .where('cardFlag').equals(row.cardFlag)
                        .where('SETDEFAULT').equals(row.SETDEFAULT);

        return RegisterCardRepository.download(query);
    };

    this.getCreditCard = function(consumer){
        return requestEngine.doRequest(requestFactory.factory({
            "requestType": "Row",
            "serviceName": "/GetCreditCard",
            "row": consumer
        }));
    };

    this.doTokenRecharge = function(valorPedido, codigoPedido, rechargeValues, CDFILIAL, creditCardInformation, appUrl, logoEmpresa){
        return requestEngine.doRequest(requestFactory.factory({
            "requestType": "Row",
            "serviceName": "/InstantBuyTransaction",
            "row": {
                "valorPedido"           : valorPedido,
                "codigoPedido"          : codigoPedido,
                "rechargeValues"        : JSON.stringify(rechargeValues),
                "CDFILIAL"              : CDFILIAL,
                "creditCardInformation" : creditCardInformation,
                "appUrl"                : appUrl,
                "logoEmpresa"           : logoEmpresa
            }
        }));
    };

    this.deleteCreditCard = function(checkedRows){
        return requestEngine.doRequest(requestFactory.factory({
            "requestType": "Row",
            "serviceName": "/DeleteCreditCard",
            "row": {
                "checkedRows": checkedRows
            }
        }));
    };

    this.setCreditCardAsDefault = function(row){
        return requestEngine.doRequest(requestFactory.factory({
            "requestType": "Row",
            "serviceName": "/SetCreditCardAsDefault",
            "row": {
                "CDCARTCRED": row.CDCARTCRED,
                "CDCLIENTE": row.CDCLIENTE,
                "CDCONSUMIDOR": row.CDCONSUMIDOR
            }
        }));
    };

    this.getAvaliableFlags = function(CDFILIAL){
        return requestEngine.doRequest(requestFactory.factory({
            "requestType": "Row",
            "serviceName": "/GetAvaliableFlags",
            "row": {
                "CDFILIAL": CDFILIAL
            }
        }));
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('CreditCardService', CreditCardService);
});